## exim4 4.88

=== debian/changelog ===
exim4 (4.88-5ubuntu1.3) zesty-security; urgency=medium

  * SECURITY UPDATE: stack-exhaustion remote DoS
    - debian/patches/CVE-2017-16944.patch: do not treat the first lonely
      dot special in src/receive.c, src/smtp_in.c.
    - CVE-2017-16944

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 29 Nov 2017 09:02:41 -0500

exim4 (4.88-5ubuntu1.2) zesty-security; urgency=medium

  * SECURITY UPDATE: remote code execution via use-after-free
    - debian/patches/CVE-2017-16943.patch: avoid release of store if there
      have been later allocations in src/receive.c.
    - CVE-2017-16943

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 27 Nov 2017 07:38:18 -0500

exim4 (4.88-5ubuntu1.1) zesty-security; urgency=medium

  * SECURITY UPDATE: memory leak
    - debian/patches/93_CVE-2017-1000368.patch: free -p argument if
      allocation was required.
    - CVE-2017-1000368

 -- Steve Beattie <sbeattie@ubuntu.com>  Fri, 02 Jun 2017 18:59:47 -0700

exim4 (4.88-5ubuntu1) zesty; urgency=medium

  * Merge from Debian unstable.
    Version 4.88 fixes CVE-2016-9963 (LP: #1654750) and symlink
    local root escalation (LP: #1580454)
    Remaining changes:
    + Show Ubuntu distribution in SMTP banner.
    + Build-Depends on lsb-release (needed for the Ubuntu SMTP banner patch)

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Tue, 24 Jan 2017 10:15:09 +0100

exim4 (4.88-5) unstable; urgency=medium

  * 78_Disable-chunking-BDAT-by-default.patch: Change default value of main
    option chunking_advertise_hosts and smtp transport option
    hosts_try_chunking from "*" to empty.
    This is a Debian specific change, we are right before the freeze and BDAT
    needs a little time.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 19 Jan 2017 19:18:15 +0100

exim4 (4.88-4) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 07 Jan 2017 14:38:00 +0100

exim4 (4.88-3) experimental; urgency=medium

  * Pull multiple patches from upstream GIT:
   + 75_00_DKIM-More-validation-of-DNS-key-record.-Bug-1926.patch,
     75_01_DKIM-Under-debug-when-signing-do-an-extra-check-on-t.patch
   + 75_02_Do-not-call-ldap_start_tls_s-on-ldapi-connections.patch
   + 75_03_PROXY-fix-v2-protocol-decode.-Bugs-2003-1747.patch
   + 75_04_CHUNKING-fix-non-pipelined-synch-checks.-Bug-2004.patch
     (Thanks, Bart Noordervliet for the pointer) Closes: #850175

 -- Andreas Metzler <ametzler@debian.org>  Fri, 06 Jan 2017 17:32:20 +0100

exim4 (4.88-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Tue, 27 Dec 2016 17:36:29 +0100

exim4 (4.88-1) experimental; urgency=medium

  * New upstream version.
  * Upload to experimental, let (almost identical) 4.88~RC6-2 propagate to
    testing.
  * Drop 75_Fix-DKIM-information-leakage.patch.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 25 Dec 2016 18:07:12 +0100

exim4 (4.88~RC6-2) unstable; urgency=high

  * Add macro IGNORE_SMTP_LINE_LENGTH_LIMIT to allow disabling the SMTP DATA
    physical line limit check for both for SMTP DATA ACL and remote_smtp*
    transports. Closes: #828801
    Also update corresponding NEWS entry.
  * [lintian] debian/changelog: s/lenght/length/
  * Pull 75_Fix-DKIM-information-leakage.patch from upstream GIT, fixing DKIM
    information leakage issue CVE-2016-9963.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 22 Dec 2016 16:50:21 +0100

exim4 (4.88~RC6-1) unstable; urgency=low

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 08 Dec 2016 07:19:18 +0100

exim4 (4.88~RC5-1) unstable; urgency=low

  * New upstream version.
    + Drop 75_01-Ensure-socket-is-nonblocking-before-draining.diff.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 19 Nov 2016 17:43:51 +0100

exim4 (4.88~RC4-2) unstable; urgency=low

  * Pull 75_01-Ensure-socket-is-nonblocking-before-draining.diff from upstream
    GIT to fix exim bug 1914 (exim doesn't close connection after quit.
  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 12 Nov 2016 07:26:14 +0100

exim4 (4.88~RC4-1) experimental; urgency=low

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 07 Nov 2016 19:08:47 +0100

exim4 (4.88~RC3-1) experimental; urgency=medium

  * New upstream version.
    Drop 75_01-Fix-check-for-commandline-macro-definition.patch
    75_02_Fix-bug-with-aborted-server-TLS-connection-under-Gnu.patch.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 24 Oct 2016 19:25:31 +0200

exim4 (4.88~RC2-3) experimental; urgency=medium

  * Fix thinko in exim4-daemon-*.postinst. Do not regenerate gnutls params on
    every upgrade.
  * 75_02_Fix-bug-with-aborted-server-TLS-connection-under-Gnu.patch: Fix
    longstanding bug with aborted TLS server connection handling. Under
    GnuTLS, when a session startup failed (eg because the client
    disconnected) Exim did stdio operations after fclose.  This was exposed by
    a recent change which nulled out the file handle after the fclose.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 23 Oct 2016 16:39:13 +0200

exim4 (4.88~RC2-2) experimental; urgency=medium

  * 75_01-Fix-check-for-commandline-macro-definition.patch - Fix permission
    problems on commandline mail submission. Closes: #840355

 -- Andreas Metzler <ametzler@debian.org>  Thu, 13 Oct 2016 19:25:07 +0200

exim4 (4.88~RC2-1) experimental; urgency=low

  *  New upstream version.
    + Changed default Diffie-Hellman parameters to be Exim-specific, created
      by Phil Pennock. Added RFC7919 DH primes as an alternative.
      Closes: #839978
  * Set tls_dhparam = historic to use site-specific DH parameters.
  * Again, ship /usr/share/exim4/exim4_refresh_gnutls-params, use it in
    -daemon postinst.
  * Initialize /var/spool/exim4/gnutls-params-2048 at daemon install, either
    by running certtool or by installing
    /usr/share/exim4/gnutls-params-2048. Do not try to use
    openssl dhparam, it takes too long.



=== debian/control ===
Source: exim4
Section: mail
Priority: standard
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>
Uploaders: Andreas Metzler <ametzler@debian.org>,Marc Haber <mh+debian-packages@zugschlus.de>
Homepage: http://www.exim.org/
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-exim4/exim4.git
Vcs-Browser: https://anonscm.debian.org/git/pkg-exim4/exim4.git
Build-Depends: debhelper (>= 9), po-debconf, docbook-xsl, xsltproc,
  lynx-cur | lynx, docbook-xml, libpcre3-dev, libldap2-dev, libpam0g-dev,
  libident-dev, libdb5.3-dev, libxmu-dev, libxt-dev, libxext-dev, libx11-dev,
  libxaw7-dev, libpq-dev, default-libmysqlclient-dev,
  libsqlite3-dev, libperl-dev, libgnutls28-dev, libsasl2-dev, lsb-release

Package: exim4-base
Architecture: any
Breaks: exim4-daemon-light (<<${Upstream-Version}),
 exim4-daemon-heavy (<<${Upstream-Version}), 
 exim4-daemon-custom (<<${Upstream-Version})
Conflicts: exim, exim-tls
Replaces: exim, exim-tls, exim4-daemon-light, exim4-daemon-heavy, exim4-daemon-custom
Depends: ${shlibs:Depends}, ${misc:Depends}, 
 cron | cron-daemon | anacron,
 exim4-config (>=4.82) | exim4-config-2, adduser, netbase, lsb-base (>= 3.0-6)
# psmisc just for exiwhat.
Recommends: psmisc, mailx
Suggests: mail-reader, eximon4, exim4-doc-html|exim4-doc-info, 
 gnutls-bin | openssl, file, spf-tools-perl, swaks
Description: support files for all Exim MTA (v4) packages
 Exim (v4) is a mail transport agent. exim4-base provides the support
 files needed by all exim4 daemon packages. You need an additional package
 containing the main executable. The available packages are:
 .
  exim4-daemon-light
  exim4-daemon-heavy
 .
 If you build exim4 from the source package locally, you can also
 build an exim4-daemon-custom package tailored to your own feature set.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: exim4-config
Architecture: all
Breaks: exim4-daemon-light (<< 4.87~RC5), exim4-daemon-heavy (<< 4.87~RC5)
Provides: exim4-config-2
Conflicts: exim, exim-tls, exim4-config, exim4-config-2, ${MTA-Conflicts}
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Description: configuration for the Exim MTA (v4)
 Exim (v4) is a mail transport agent. exim4-config provides the configuration
 for the exim4 daemon packages. The configuration framework has been split
 off the main package to allow sites to replace the configuration scheme
 with their own without having to change the actual exim4 packages.
 .
 Sites with special configuration needs (having a lot of identically
 configured machines for example) can use this to distribute their own
 custom configuration via the packaging system, using the magic
 available with dpkg's conffile handling, without having to do local
 changes on all of these machines.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: exim4-daemon-light
Architecture: any
Provides: mail-transport-agent, exim4-localscanapi-2.0,
 ${dist:Provides:exim4-daemon-light}
Conflicts: mail-transport-agent
Replaces: mail-transport-agent, exim4-base (<= 4.61-1)
Depends: exim4-base (>= ${Upstream-Version}), ${shlibs:Depends}, ${misc:Depends}
Description: lightweight Exim MTA (v4) daemon
 Exim (v4) is a mail transport agent. This package contains the exim4
 daemon with only basic features enabled. It works well with the
 standard setups that are provided by Debian and includes support for
 TLS encryption and the dlopen patch to allow dynamic loading of a
 local_scan function.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: exim4
Architecture: all
Depends: ${misc:Depends}, debconf (>= 1.4.69) | cdebconf (>= 0.39),
 exim4-base (>= ${source:Version}),
 exim4-base (<< ${source:Version}.1),
 exim4-daemon-light | exim4-daemon-heavy | exim4-daemon-custom
Description: metapackage to ease Exim MTA (v4) installation
 Exim (v4) is a mail transport agent. exim4 is the metapackage depending
 on the essential components for a basic exim4 installation.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: exim4-daemon-heavy
Architecture: any
Priority: optional
Provides: mail-transport-agent, exim4-localscanapi-2.0
Conflicts: mail-transport-agent
Replaces: mail-transport-agent, exim4-base (<= 4.61-1)
Depends: exim4-base (>= ${Upstream-Version}), ${shlibs:Depends},
 ${misc:Depends}
Breaks: clamav-daemon (<< 0.95)
Description: Exim MTA (v4) daemon with extended features, including exiscan-acl
 Exim (v4) is a mail transport agent. This package contains the exim4
 daemon with extended features. In addition to the features already
 supported by exim4-daemon-light, exim4-daemon-heavy includes LDAP,
 sqlite, PostgreSQL and MySQL data lookups, SASL and SPA SMTP authentication,
 embedded Perl interpreter, and the content scanning extension
 (formerly known as "exiscan-acl") for integration of virus scanners
 and spamassassin.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

#Package: exim4-daemon-custom
#Architecture: any
#Priority: optional
#Provides: mail-transport-agent, exim4-localscanapi-2.0
#Conflicts: mail-transport-agent
#Replaces: mail-transport-agent, exim4-base (<= 4.61-1)
#Depends: exim4-base (>= ${Upstream-Version}), ${shlibs:Depends}, ${misc:Depends}
#Description: custom Exim MTA (v4) daemon with locally set features
# Exim (v4) is a mail transport agent. This package contains a
# custom-configured exim4 daemon compiled to local needs. This package
# is not part of official Debian, but can easily be built from the
# Debian source package. For information about the feature set compiled in,
# and for bug reports, please find out who built your package.
# .
# The Debian exim4 packages have their own web page,
# http://wiki.debian.org/PkgExim4. There is also a Debian-specific
# FAQ list. Information about the way the Debian packages are
# configured can be found in
# /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
# information about the way the Debian binary packages are built. The
# very extensive upstream documentation is shipped in
# /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
# configuration process in a standard setup, invoke dpkg-reconfigure
# exim4-config. There is a Debian-centered mailing list,
# pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
# questions there, and only write to the upstream exim-users mailing
# list if you are sure that your question is not Debian-specific. You
# can find the subscription web page on
# http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: eximon4
Architecture: any
Priority: optional
Conflicts: eximon
Replaces: eximon
Depends: ${shlibs:Depends}, ${misc:Depends}, exim4-base (>= 4.10)
Description: monitor application for the Exim MTA (v4) (X11 interface)
 Eximon is a helper program for the Exim MTA (v4). It allows
 administrators to view the mail queue and logs, and perform a variety
 of actions on queued messages, such as freezing, bouncing and thawing
 messages.

Package: exim4-dbg
Architecture: any
Priority: extra
Section: debug
Depends: exim4-base, exim4-config, ${misc:Depends}
Recommends: eximon4
Description: debugging symbols for the Exim MTA (utilities)
 Exim (v4) is a mail transport agent. This package contains
 debugging symbols for the binaries contained in the exim4
 packages. The daemon packages have their own debug package.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in

## exim4 4.89

=== Makefile ===
# Top-level makefile for Exim; handles creating a build directory with
# appropriate links, and then creating and running the main makefile in that
# directory.

# Copyright (c) University of Cambridge, 1995 - 2015
# See the file NOTICE for conditions of use and distribution.

# IRIX make uses the shell that is in the SHELL variable, which often defaults
# to csh, so put this in to make it use the Bourne shell. In systems where
# /bin/sh is not a Bourne-compatible shell, this line will have to be edited,
# or "make" must be called with a different SHELL= setting.

SHELL=/bin/sh
RM_COMMAND=/bin/rm

# If a build name has not been specified by running this make file via a
# command of the form "make build=xxxx", then determine the name of the
# operating system and the machine architecture and use that. This does not
# provide an override for the OS type and architecture type; they still have
# to be used for the OS-specific files. To override them, you can set the
# shell variables OSTYPE and ARCHTYPE when running make.
#
# EXIM_BUILD_SUFFIX should be used to enable parallel builds on a file
# system shared among different Linux distros (same os-type, same
# arch-type). The ../test/runtest script is expected to honour the
# EXIM_BUILD_SUFFIX when searching the Exim binary.
# NOTE: EXIM_BUILD_SUFFIX is considered *experimental*.

buildname=$${build:-`$(SHELL) scripts/os-type`-`$(SHELL) scripts/arch-type`}$${EXIM_BUILD_SUFFIX:+.$$EXIM_BUILD_SUFFIX}

# The default target checks for the existence of Local/Makefile, that the main
# makefile is built and up-to-date, and then it runs it.

all: Local/Makefile configure
	@cd build-$(buildname); $(MAKE) SHELL=$(SHELL) $(MFLAGS)


# This pair for the convenience of of the Debian maintainers
exim: Local/Makefile configure
	@cd build-$(buildname); $(MAKE) SHELL=$(SHELL) $(MFLAGS) exim
utils: Local/Makefile configure
	@cd build-$(buildname); $(MAKE) SHELL=$(SHELL) $(MFLAGS) utils


Local/Makefile:
	@echo ""
	@echo "*** Please create Local/Makefile by copying src/EDITME and making"
	@echo "*** appropriate changes for your site."
	@echo ""
	@test ! -d Local && mkdir Local
	@false

# This is separated off so that "make build-directory" can be obeyed on
# its own if necessary.

build-directory:
	@builddir=build-$(buildname); \
	case "$$builddir" in *UnKnown*) exit 1;; esac; \
	$(SHELL) -c "test -d $$builddir -a -r $$builddir/version.c || \
	  (mkdir $$builddir; cd $$builddir; $(SHELL) ../scripts/MakeLinks)";

checks:
	$(SHELL) scripts/source_checks

# The "configure" target ensures that the build directory exists, then arranges
# to build the main makefile from inside the build directory, by calling the
# Configure-Makefile script. This does its own dependency checking because of
# the optional files.

configure: checks build-directory
	@cd build-$(buildname); \
	  build=$(build) $(SHELL) ../scripts/Configure-Makefile

# The "makefile" target forces a rebuild of the makefile (as opposed to
# "configure", which doesn't force it).

makefile: build-directory
	@cd build-$(buildname); $(RM_COMMAND) -f Makefile; \
	  build=$(build) $(SHELL) ../scripts/Configure-Makefile

# The installation commands are kept in a separate script, which expects
# to be run from inside the build directory.

install:        all
		@cd build-$(buildname); \
		build=$(build) $(SHELL) ../scripts/exim_install $(INSTALL_ARG)

# Tidy-up targets

clean:; @echo ""; echo '*** "make clean" just removes all .o and .a files'
	@echo '*** Use "make makefile" to force a rebuild of the makefile'
	@echo ""
	cd build-$(buildname); \
	$(RM_COMMAND) -f *.o lookups/*.o lookups/*.a auths/*.o auths/*.a \
	routers/*.o routers/*.a transports/*.o transports/*.a \
	pdkim/*.o pdkim/*.a

clean_exim:; cd build-$(buildname); \
	 $(RM_COMMAND) -f *.o lookups/*.o lookups/*.a auths/*.o auths/*.a \
	routers/*.o routers/*.a transports/*.o transports/*.a lookups/*.so

distclean:; $(RM_COMMAND) -rf build-* cscope*

cscope.files: FRC
	echo "-q" > $@
	echo "-p3" >> $@
	find src Local OS exim_monitor -name "*.[cshyl]" -print \
		    -o -name "os.h*" -print \
		    -o -name "*akefile*" -print \
		    -o -name config.h.defaults -print \
		    -o -name EDITME -print >> $@
	ls OS/* >> $@

FRC:

# End of top-level makefile

=== debian/changelog ===
exim4 (4.89-2+deb9u8) stretch-security; urgency=high

  * Non-maintainer upload by the LTS Team.
  * Fix several security vulnerabilities reported by Qualys and add related
    robustness improvements. (Originally fixed in upstream release 4.94.3 and
    in upstream GIT branch exim-4.92.3+fixes. (Special thanks to Heiko)
    + CVE-2020-28007: Link attack in Exim's log directory
    + CVE-2020-28008: Assorted attacks in Exim's spool directory
    + CVE-2020-28009: Integer overflow in get_stdinput()
    + CVE-2020-28011: Heap buffer overflow in queue_run()
    + CVE-2020-28012: Missing close-on-exec flag for privileged pipe
    + CVE-2020-28013: Heap buffer overflow in parse_fix_phrase()
    + CVE-2020-28014, CVE-2021-27216: Arbitrary PID file creation, clobbering,
      and deletion.
    + CVE-2020-28015 and CVE-2020-28021: New-line injection into spool header
      file.
    + CVE-2020-28017: Integer overflow in receive_add_recipient()
    + CVE-2020-28019: Failure to reset function pointer after BDAT error
    + CVE-2020-28020: More checks on header line length during reception
    + CVE-2020-28022: Heap out-of-bounds read and write in extract_option()
    + CVE-2020-28023: Out-of-bounds read in smtp_setup_msg()
    + CVE-2020-28024: Heap buffer underflow in smtp_ungetc()
    + CVE-2020-28025: Heap out-of-bounds read in pdkim_finish_bodyhash()
    + CVE-2020-28026: Line truncation and injection in spool_read_header()

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 04 May 2021 11:03:02 +0200

exim4 (4.89-2+deb9u7) stretch-security; urgency=high

  * Fix authentication bypass in SPA authenticator due to out-of-bound buffer
    read. https://bugs.exim.org/show_bug.cgi?id=2571 CVE-2020-12783

 -- Andreas Metzler <ametzler@debian.org>  Wed, 13 May 2020 18:18:26 +0200

exim4 (4.89-2+deb9u6) stretch-security; urgency=high

  * 85_01-string.c-do-not-interpret-before-0-CVE-2019-15846.patch Fix SNI
    related buffer overflow. CVE-2019-15846

 -- Andreas Metzler <ametzler@debian.org>  Tue, 03 Sep 2019 20:01:38 +0200

exim4 (4.89-2+deb9u5) stretch-security; urgency=high

  * Fix remote command execution vulnerability related to
    "${sort}"-expansion. CVE-2019-13917 OVE-20190718-0006

 -- Andreas Metzler <ametzler@debian.org>  Sat, 20 Jul 2019 13:32:35 +0200

exim4 (4.89-2+deb9u4) stretch-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Fix remote command execution vulnerability (CVE-2019-10149)

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 28 May 2019 22:13:55 +0200

exim4 (4.89-2+deb9u3) stretch-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Fix base64d() buffer size (CVE-2018-6789) (Closes: #890000)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 10 Feb 2018 09:26:05 +0100

exim4 (4.89-2+deb9u2) stretch-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Avoid release of store if there have been later allocations
    (CVE-2017-16943) (Closes: #882648)
  * Chunking: do not treat the first lonely dot special (CVE-2017-16944)
    (Closes: #882671)

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 28 Nov 2017 22:58:00 +0100

exim4 (4.89-2+deb9u1) stretch-security; urgency=medium

  * CVE-2017-100369

 --  <jmm@debian.org>  Wed, 14 Jun 2017 07:03:07 +0200

exim4 (4.89-2) unstable; urgency=medium

  * Revert addition of header "# pidfile: /var/run/exim4/exim.pid" to
    initscript (#844178). It breaks when the initscript does not start a
    daemon but only runs update-exim4.conf. (inetd or QUEUERUNNER='nodaemon').
    Closes: #860317
  * When reporting bugs also attach /etc/default/exim4 by default.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 20 Apr 2017 17:14:04 +0200

exim4 (4.89-1) unstable; urgency=medium

  * Enable inbound (server-side) proxying for -heavy. Closes: #856712
  * New upstream release, source identical to RC7.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 09 Mar 2017 17:49:47 +0100

exim4 (4.89~RC7-1) unstable; urgency=medium

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Wed, 01 Mar 2017 18:37:18 +0100

exim4 (4.89~RC6-1) unstable; urgency=medium

  * Document E4BCD_PANICLOG_LINES in README.Debian.
  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 23 Feb 2017 18:24:33 +0100

exim4 (4.89~RC5-1) unstable; urgency=medium

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 13 Feb 2017 19:04:46 +0100

exim4 (4.89~RC4-1) unstable; urgency=medium

  * New upstream version.
    + Drop 92_CVE-2016-1238.diff.
  * Use /run/exim4/ instead of legacy directory /var/run/exim4 for pidfile
    while we are changing the init script.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 12 Feb 2017 15:28:09 +0100

exim4 (4.89~RC3-1) unstable; urgency=medium

  * New upstream version.
    + Unfuzz 92_CVE-2016-1238.diff.
  * init file:
    + Source /etc/default/exim4 *before* defining the shell
      variables holding the pidfilenames. Overriding these via
      /etc/default/exim4 is not supported.
    + Add missing support for reload when QUEUERUNNER='queueonly'.
    + For QUEUERUNNER='queueonly' use $PIDFILE instead of $QRPIDFILE. This way
      $PIDFILE is used for the main exim process for all available QUEUERUNNER
      choices.
    + Add header "# pidfile: /var/run/exim4/exim.pid" for improved systemd
      interaction. systemd-sysv-generator uses this pseudoheader to set
      PIDFile in the generated service file and it also sets
      RemainAfterExit=no instead of yes if it is present. Thanks, Michael
      Biebl for suggestion and explanation. Closes: #844178

 -- Andreas Metzler <ametzler@debian.org>  Fri, 10 Feb 2017 19:08:52 +0100

exim4 (4.89~RC2-1) unstable; urgency=medium

  * New upstream version.
    + Drop 75_add_bak_spec.txt.diff.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 04 Feb 2017 15:24:44 +0100

exim4 (4.89~RC1-1) unstable; urgency=low

  * Refresh debian/upstream/signing-key.asc.


=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: exim4
 Section: mail
 Priority: standard
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>
+Maintainer: Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>
 Uploaders: Andreas Metzler <ametzler@debian.org>,Marc Haber <mh+debian-packages@zugschlus.de>
 Homepage: http://www.exim.org/
 Standards-Version: 3.9.8
@@ -12,7 +11,7 @@
   lynx-cur | lynx, docbook-xml, libpcre3-dev, libldap2-dev, libpam0g-dev,
   libident-dev, libdb5.3-dev, libxmu-dev, libxt-dev, libxext-dev, libx11-dev,
   libxaw7-dev, libpq-dev, default-libmysqlclient-dev,
-  libsqlite3-dev, libperl-dev, libgnutls28-dev, libsasl2-dev, lsb-release
+  libsqlite3-dev, libperl-dev, libgnutls28-dev, libsasl2-dev
 
 Package: exim4-base
 Architecture: any
@@ -236,3 +235,5 @@
  http://wiki.debian.org/PkgExim4. There is also a Debian-specific
  FAQ list. Information about the way the Debian packages are
  configured can be found in
+ /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
+ information about the way the Debian binary packages are built. The

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for exim4
# This file is public domain software, originally written by Joey Hess.
#
# Uncomment this to turn on verbose mode. 
# export DH_VERBOSE=1

buildname := $(shell scripts/os-type)-$(shell scripts/arch-type)
DEBIAN := $(shell pwd)/debian

ifeq ($(wildcard /usr/share/dpkg/buildflags.mk),) 
CFLAGS := -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif
else
export DEB_BUILD_MAINT_OPTIONS := hardening=+bindnow,+pie
DPKG_EXPORT_BUILDFLAGS := 1
include /usr/share/dpkg/buildflags.mk
endif

# The build system ignores CPPFLAGS, append them to CFLAGS
CFLAGS := $(CFLAGS) $(shell getconf LFS_CFLAGS) -D_LARGEFILE_SOURCE -fno-strict-aliasing -Wall $(CPPFLAGS)
export CFLAGS
# LFLAGS is used where GNU would use LDFLAGS
export LFLAGS += $(LDFLAGS)

LC_ALL=C
export LC_ALL

# Which packages should we build?
ifndef buildbasepackages
buildbasepackages=yes
endif

ifndef extradaemonpackages
extradaemonpackages=exim4-daemon-heavy
endif
# If you want to build a daemon with a configuration tailored to YOUR special
# needs, uncomment the two custom packages in debian/control
# call "fakeroot debian/rules unpack-configs", copy EDITME.exim4-light
# to EDITME.exim4-custom and modify it. Please note that you _need_ to
# modify EDITME.exim4-custom or your build will fail due to #386188.
#
# If you want to create multiple custom packages with different names, use
# the script debian/create-custom-package [suffix].
#
# Afterwards EITHER change the definition of extradaemonpackages above OR
# simply set extradaemonpackages to the desired value via the environment.

# If you want your changes to survive a debian/rules clean, call
# "fakeroot debian/rules pack-configs" after customizing EDITME.exim4-custom

# If you remove exim4-daemon-light from basedaemonpackages to prevent
# exim4-daemon-light from being built, you need to modify the build
# process to pull the helper binaries from the daemon package that you
# actually build. If you simply remove exim4-daemon-light here, you will
# end up with exim4-base sans binaries, which is most probably not what
# you intend to have.
#
# combined[ai]dbgpackage has a list of packages whose debug information
# goes into the combined debug package exim4-dbg, separated as arch
# independent and arch dependent list.
# extraadbgpackage has a list of packages whose debug information
# goes into one debug package foo-dbg per package. This is currently
# only implemented and needed for arch dependent packages.

ifeq ($(buildbasepackages),yes)
basedaemonpackages=exim4-daemon-light
combinedadbgpackage=exim4-base eximon4
exim4dbg=exim4-dbg
dhstripparm=--dbg-package=$(exim4dbg)
exim4dev=exim4-dev
extraadbgpackage=$(basedaemonpackages) $(extradaemonpackages)
else
basedaemonpackages=
combinedadbgpackage=
exim4dbg=
dhstripparm=
exim4dev=
extraadbgpackage=$(extradaemonpackages)
endif

# If you want to build with OpenSSL instead of GnuTLS, uncomment this
# OPENSSL:=1
# Please note that building exim4-daemon-heavy with OpenSSL is a GPL
# violation.


# list of all arch dependent packages to be built
buildpackages=$(combinedadbgpackage) $(extraadbgpackage) $(addsuffix -dbg,$(extraadbgpackage)) $(exim4dbg) $(exim4dev)
# generate -pexim4-base -peximon4 ... commandline for debhelper
dhbuildpackages=$(addprefix -p,$(buildpackages))
dhcombinedadbgpackage=$(addprefix -p,$(combinedadbgpackage))

# exim4-daemon-heavy --> b-exim4-daemon-heavy/build-Linux-x86_64/exim
daemonbinaries=$(addprefix b-,$(addsuffix /build-$(buildname)/exim,$(extradaemonpackages)))
debiandaemonbinaries=$(addprefix $(DEBIAN)/,$(addsuffix /usr/sbin/exim4,$(extradaemonpackages)))
BDIRS=$(addprefix b-,$(extradaemonpackages) $(basedaemonpackages))


# get upstream-version from debian/changelog, i.e. anything until the first -
DEBVERSION := $(shell dpkg-parsechangelog | sed -n '/^Version: /s/^Version: //p')
UPSTREAMVERSION := $(shell echo $(DEBVERSION) | sed -n 's/\(.\+\)-[^-]\+/\1/p')
DEBTIME := $(shell dpkg-parsechangelog --show-field Date)
REPBUILDDATE := \
	$(shell env LC_ALL=C TZ=UTC date --date="$(DEBTIME)" '+%b %e %Y')
REPBUILDTIME := \
	$(shell env LC_ALL=C TZ=UTC date --date="$(DEBTIME)" '+%H:%M:%S')

PROVIDE_DEFAULT_MTA := $(shell if dpkg-vendor --is Ubuntu || \
	dpkg-vendor --derives-from Ubuntu ; then : ; else \
	echo "default-mta" ; fi)
# for reproducible build. If set exim would use $TZ as default value for
# TIMEZONE_DEFAULT
undefine TZ
unexport TZ


# set up build directory b-exim4-daemon-heavy/
$(addsuffix /Makefile,$(BDIRS)): %/Makefile:
	mkdir $*
	find . -mindepth 1 -maxdepth 1 \
		-name debian -prune -o \
		-name 'b-*' -o -print0 | \
		xargs --no-run-if-empty --null \
		cp -a --target-directory=$*
	printf '#define REPBUILDDATE "$(REPBUILDDATE)"\n' \
		> $*/src/repbuildtime.h && \
		printf '#define REPBUILDTIME "$(REPBUILDTIME)"\n' \
		>> $*/src/repbuildtime.h


unpack-configs: unpack-configs-stamp
unpack-configs-stamp: src/EDITME exim_monitor/EDITME
	patch -o EDITME.eximon exim_monitor/EDITME \
		$(DEBIAN)/EDITME.eximon.diff
	patch -o EDITME.exim4-light src/EDITME \
		$(DEBIAN)/EDITME.exim4-light.diff
ifdef OPENSSL
	patch EDITME.exim4-light $(DEBIAN)/EDITME.openssl.exim4-light.diff
endif
	for editme in $(DEBIAN)/EDITME.exim4-*.diff; do \
	  if [ "$$editme" != "$(DEBIAN)/EDITME.exim4-light.diff" ]; then \
	    TARGETNAME=`basename $$editme .diff`; \
	    echo patch -o $$TARGETNAME EDITME.exim4-light $$editme; \
	    patch -o $$TARGETNAME EDITME.exim4-light $$editme || \
	    exit $$? ;\
	  fi; \
	done
	touch unpack-configs-stamp

pack-configs:
	-diff -u src/EDITME EDITME.exim4-light \
		> $(DEBIAN)/EDITME.exim4-light.diff
	-for editme in EDITME.exim4-*; do \
	  if [ "$$editme" != "EDITME.exim4-light" ]; then \
	    echo diff -u EDITME.exim4-light $$editme; \
	    diff -u EDITME.exim4-light $$editme > $(DEBIAN)/$${editme}.diff; \
	  fi; \
	done
	-diff -u exim_monitor/EDITME EDITME.eximon \
		> $(DEBIAN)/EDITME.eximon.diff

# only called manually by maintainer before upload.
update-mtaconflicts:
	which grep-available > /dev/null && \
		grep-available --show-field=Package --field=Provides \
		mail-transport-agent --no-field-names \
		/var/lib/apt/lists/*Packages | grep -v exim | sort -u | \
		tr '\n' ',' | sed -e 's/,/, /g;s/, $$//' > $(DEBIAN)/mtalist

# Generate README.Debian as text/html ...
debian/README.Debian.html: debian/README.Debian.xml
	xsltproc --nonet --stringparam section.autolabel 1 \
		-o $@ \
		/usr/share/xml/docbook/stylesheet/nwalsh/html/docbook.xsl \
		$<
# ... and text/plain
debian/README.Debian: debian/README.Debian.html
	chmod 755 $(DEBIAN)/lynx-dump-postprocess
	lynx -force_html -dump $< | $(DEBIAN)/lynx-dump-postprocess > $@.tmp
	mv $@.tmp $@

configure: configure-stamp

configure-stamp: $(addsuffix /Makefile,$(BDIRS)) unpack-configs-stamp
	dh_testdir
	# Add here commands to configure the package.
	touch $@ 

# Build binaries for the base package, the eximon4 package, and the
# exim4-daemon-light package.
b-exim4-daemon-light/build-$(buildname)/exim: b-exim4-daemon-light/Makefile configure-stamp
	@echo build $(<D)
	dh_testdir

	rm -rf $(@D)
	mkdir -p $(<D)/Local
	cp EDITME.exim4-light $(<D)/Local/Makefile
	cp EDITME.eximon $(<D)/Local/eximon.conf
	cd $(<D) && $(MAKE) FULLECHO=''

b-exim4-daemon-heavy/build-$(buildname)/exim: b-exim4-daemon-heavy/Makefile configure-stamp
	@echo build $(<D)
	dh_testdir

	rm -rf $(@D)
	mkdir -p $(<D)/Local
	cp EDITME.exim4-heavy $(<D)/Local/Makefile
	cd $(<D) && $(MAKE) FULLECHO=''

b-exim4-daemon-custom/build-$(buildname)/exim: b-exim4-daemon-custom/Makefile configure-stamp
	@echo build $(<D)
	dh_testdir

	rm -rf $(@D)
	mkdir -p $(<D)/Local
	cp EDITME.exim4-custom $(<D)/Local/Makefile
	cd $(<D) && $(MAKE) FULLECHO=''

build-indep: build-indep-stamp
build-indep-stamp: debian/README.Debian
	dh_testdir
	touch $@

build-arch: build-arch-stamp test-stamp

ifeq ($(buildbasepackages),yes)

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/,uversionmangle=s/_/~/ \
http://ftp.exim.org/pub/exim/exim4/exim-(\d.*)\.(?:tgz|tar\.(?:gz|bz2|xz))
